       cbl dll,thread,rent,pgmname(longmixed),lib
       Identification Division.
       Class-id. Account inherits Base.
       Environment Division.
       Configuration section.
       Repository.
           Class Base is "java.lang.Object"
           Class Account is "Account".
       Identification division.
       Factory.
        Data division.
        Working-storage section.
        01 NumberOfAccounts pic 9(6) value zero.

        Procedure Division.
         Identification Division.
         Method-id. "createAccount".
         Data division.
         Linkage section.
         01 inAccountNumber  pic S9(6) binary.
         01 outAccount object reference Account.
           Copy JNI.
         Procedure Division using by value inAccountNumber
             returning outAccount.
           Set address of JNIEnv to JNIEnvPtr
           Set address of JNINativeInterface to JNIEnv

           Invoke Account New returning outAccount
           Invoke outAccount "init" using by value inAccountNumber
           Add 1 to NumberOfAccounts.
         End method "createAccount".
       End Factory.

       Identification division.
       Object.
        Data division.
        Working-storage section.
        01 AccountNumber pic 9(6).
        01 AccountBalance pic S9(9) value zero.
        Procedure Division.

         Identification Division.
         Method-id. "init".
         Data division.
         Linkage section.
         01 inAccountNumber pic S9(9) binary.
         Procedure Division using by value inAccountNumber.
            Move inAccountNumber to AccountNumber.
         End method "init".

         Identification Division.
         Method-id. "getBalance".
         Data division.
         Linkage section.
         01 outBalance pic S9(9) binary.
         Procedure Division returning outBalance.
           Move AccountBalance to outBalance.
         End method "getBalance".

         Identification Division.
         Method-id. "credit".
         Data division.
         Linkage section.
         01 inCredit   pic S9(9) binary.
         Procedure Division using by value inCredit.
           Add inCredit to AccountBalance.
         End method "credit".

         Identification Division.
         Method-id. "debit".
         Data division.
         Linkage section.
         01 inDebit    pic S9(9) binary.
         Procedure Division using by value inDebit.
           Subtract inDebit from AccountBalance.
         End method "debit".

         Identification Division.
         Method-id. "print".
         Data division.
         Local-storage section.
         01 PrintableAccountNumber  pic ZZZZZZ999999.
         01 PrintableAccountBalance pic $$$$,$$$,$$9CR.
         Procedure Division.
           Move AccountNumber  to PrintableAccountNumber
           Move AccountBalance to PrintableAccountBalance
           Display " Account: " PrintableAccountNumber
           Display " Balance: " PrintableAccountBalance.
         End method "print".

       End Object.
       End class Account.

