#
# Makefile for the OO COBOL and Java application
#

all:Account.dll CheckingAccount.dll TestAccounts.exe Account.class CheckingAccount.class Check.class
TestAccounts.exe: TestAccounts.obj
        cob2 TestAccounts.obj
TestAccounts.obj: TestAccounts.cbl
        cob2 -c TestAccounts.cbl
Check.class: Check.java
        javac Check.java
Account.dll: Account.obj
        cob2 -dll Account.obj
Account.obj: Account.cbl
        cob2 -c Account.cbl
CheckingAccount.dll: CheckingAccount.obj
        cob2 -dll CheckingAccount.obj
CheckingAccount.obj: CheckingAccount.cbl
        cob2 -c CheckingAccount.cbl
Account.class: Account.java
        javac Account.java
CheckingAccount.class: CheckingAccount.java
        javac CheckingAccount.java
clean:
        del TestAccounts.exe Account.java CheckingAccount.java *.dll *.obj *.class *.lst *.exp *.lib *.imp
